#include <stdio.h>
#include <vector>
#include <string>
#include <map>
#include <string.h>
#include <ctype.h>
using namespace std;

char oldagdef[1000000];
char oldagrule[1000000];

int syms,rules,states;

vector<int> nt;
vector<string> name;
map<string,int> tok;
vector<int> lhs;
vector<vector<int> > rhs;

struct statesym {
   statesym(int a, int b) {state = a; sym = b;}
   int state, sym;
};

int operator<(const statesym &a, const statesym &b){
   if (a.state == b.state) return a.sym < b.sym;
   return a.state < b.state;
}

map<statesym,int> trans;

map<int,string> rulename;

int readgram(){
   FILE *tbl;
   int i,j,k,m,n;  char tmp[10000];
   tbl = fopen("slr.tbl","r");
   if (tbl == NULL) {perror("slr.tbl"); return 0;}

   fscanf(tbl,"%d%d%d",&syms,&rules,&states);
   for (i=0;i<syms;i++) {
      fscanf(tbl,"%d%s",&j,tmp);
      nt.push_back(j);
      name.push_back(tmp);
      if (!j) tok[tmp] = i;
   }
   for (i=0;i<rules;i++){
      fscanf(tbl,"%d%d",&j,&k);
      lhs.push_back(j);
      rhs.push_back(vector<int>(0));
      for (m=0;m<k;m++) {
         fscanf(tbl,"%d",&n);
         rhs[i].push_back(n);
      }
   }
/*
   for (i=0;i<states;i++) {
      fscanf(tbl,"%d",&j);
      for (k=0;k<j;k++) {
         fscanf(tbl,"%d%d",&m,&n);
         trans[statesym(i,m)] = n;
      }
   }
*/
   fclose(tbl);
   return 1;
}

int printgram(){
   int i,j;
   for (i=0;i<syms;i++) {
      if (nt[i]) printf("%s\n",name[i].c_str());
   }
   for (i=0;i<syms;i++) {
      if (!nt[i]) printf("%s %d\n",name[i].c_str(),tok[name[i]]);
   }
   for (i=0;i<rules;i++) {
      printf("%s ->",name[lhs[i]].c_str());
      for (j=0;j<rhs[i].size();j++) printf(" %s",name[rhs[i][j]].c_str());
      printf("\n");
   }

   for (map<statesym,int>::iterator p = trans.begin(); p != trans.end(); *p++){
      printf("trans %d %d %d\n",p->first.state,p->first.sym,p->second);
   }
   return 1;
}

const char * cvt(string x){
   if (isalpha(x[0])) return strdup(x.c_str());
   if (isdigit(x[0])) return strdup(("N"+x).c_str());
   switch (x[0]) {
   case '<': return "lt";
   case '>': return "gt";
   case '=': return "eq";
   case ':': return "colon";
   case '+': return "plus";
   case '-': return "minus";
   case '*': return "star";
   case '/': return "slash";
   case '(': return "lparen";
   case ')': return "rparen";
   case '}': return "rbrace";
   case '{': return "lbrace";
   case '_': return "underscore";
   }
   return "symbol";
};

const char * nit(int ru, int po){
   int i,j,k;  char tmp[100];
   if (po == -1) return cvt(name[lhs[ru]] + "0");
   for (i=0,j=1;i<po;i++) if (rhs[ru][i] == rhs[ru][po]) j++;
   sprintf(tmp,"%d",j);
   return strdup((string(cvt(name[rhs[ru][po]]))+tmp).c_str());
}

int printc(){
   int i,j,k,m,n,z;
   FILE *ag = fopen("agdef.h","r");
   if (ag) {
      fread(oldagdef,1,999999,ag);
      fclose(ag);
   }
   if(ag = fopen("agrule.cc","r")){
      fread(oldagrule,1,999999,ag);
      fclose(ag);
   }
   freopen("agdef.h","a",stdout);
   if (!strstr(oldagdef,"#include \"attr.h\"")) printf("#include \"attr.h\"\n\n");

   //printf("struct sym {\n   sym *parent;\n   virtual int eval(void *) = 0;\n};\n\n");

   //printf("struct trm: sym {\n   // attributes for terminals are pre-defined\n   int line;\n   int col;\n   char * txt;\n};\n\n");
   if (!strstr(oldagdef,"struct nt:")) printf("struct nt: sym {\n   // attributes common for all nonterminals\n};\n\n");
   for (i=0;i<syms;i++) {
      if (!nt[i]) continue;
      char tmp[1000];
      sprintf(tmp,"struct %s:",cvt(name[i]));
      if (strstr(oldagdef,tmp)) continue;
      printf("struct %s: nt {\n   // attributes for %s\n\n   string display();\n};\n\n",cvt(name[i]),cvt(name[i]));
   }
   freopen("agrule.h","w",stdout);
   printf("#include <stdio.h>\n\n");

   for (i=0;i<rules;i++) {
         string foo = cvt(name[lhs[i]]);
         if (rhs[i].size() == 0) foo += "_";
         for (j=0;j<rhs[i].size();j++){
            //printf("name %s cvt %s ",name[rhs[i][j]].c_str(),cvt(name[rhs[i][j]]));
            foo = foo + "_" + cvt(name[rhs[i][j]]);
         }
         rulename[i] = foo;
         printf("struct %s: %s{\n",foo.c_str(),name[lhs[i]].c_str());
         printf("   %s& %s1;\n",name[lhs[i]].c_str(),name[lhs[i]].c_str());
         for (j=0;j<rhs[i].size();j++) {
            for (k=0,m=1+(lhs[i]==rhs[i][j]);k<j;k++) if (rhs[i][j] == rhs[i][k]) m++;
            printf("   %s& %s%d;\n",nt[rhs[i][j]]?cvt(name[rhs[i][j]]):"trm",cvt(name[rhs[i][j]]),m);
         }
         printf("   int eval(void *);\n");
         printf("   %s(vector<sym *>_x): ",foo.c_str());
         printf("%s1(*this)",name[lhs[i]].c_str());
         for (j=0;j<rhs[i].size();j++) {
            for (k=0,m=1+(lhs[i]==rhs[i][j]);k<j;k++) if (rhs[i][j] == rhs[i][k]) m++;
            printf(", %s%d(*(%s *)_x[%d])",cvt(name[rhs[i][j]]),m,nt[rhs[i][j]]?cvt(name[rhs[i][j]]):"trm",j);
         }
         printf("{}\n");
         printf("};\n");
/*
         printf("int %s::eval(void * _w){\n",foo.c_str());
         printf("   // ");
         printf("%s ->",name[lhs[i]].c_str());
         for (j=0;j<rhs[i].size();j++) {
            for (k=0,m=1+(lhs[i]==rhs[i][j]);k<j;k++) if (rhs[i][j] == rhs[i][k]) m++;
            printf(" %s",name[rhs[i][j]].c_str());
         }
         printf("\n");
         printf("printf(\"eval %%x parent %%x nt %s \",this,parent);\n",name[lhs[i]].c_str());
         for (j=0;j<rhs[i].size();j++) {
            for (k=0,m=1+(lhs[i]==rhs[i][j]);k<j;k++) if (rhs[i][j] == rhs[i][k]) m++;
            printf("printf(\" %%x\",&%s%d);\n",cvt(name[rhs[i][j]]),m);
         }
         printf("printf(\"\\n\");");
         printf("\n   return 0;\n}\n\n");
*/
   }

   printf("sym * build(int rule, vector<sym *> rhs){\n");
   printf("switch(rule) {\n");
   for (i=0;i<rules;i++) {
      printf("case %d: return new %s(rhs);\n",i,rulename[i].c_str());
   }
   printf("\n}}\n");

   char tmp[1000];
   freopen("agrule.cc","a",stdout);
   if (!strstr(oldagrule,"#include \"agrule.h\"")){
      printf("#include \"agdef.h\"\n");
      printf("#include \"agrule.h\"\n\n");
   }

   for (i=0;i<syms;i++) {
      if (!nt[i]) continue;
      char tmp[1000];
      sprintf(tmp,"string %s::display(){\n",cvt(name[i]));
      if (strstr(oldagrule,tmp)) continue;
      printf(tmp);
      printf("   return \"<no attribute display>\";\n}\n\n");
   }

   for (i=0;i<rules;i++) {
         char tmp[1000];
         sprintf(tmp,"AGRULE(%s)",rulename[i].c_str());
         if (strstr(oldagrule,tmp)) continue;
         //printf("int %s::eval(void * _w){\n",rulename[i].c_str());
         printf("AGRULE(%s)\n",rulename[i].c_str());
         printf("   // ");
         printf("%s ->",name[lhs[i]].c_str());
         for (j=0;j<rhs[i].size();j++) {
            for (k=0,m=1+(lhs[i]==rhs[i][j]);k<j;k++) if (rhs[i][j] == rhs[i][k]) m++;
            printf(" %s",name[rhs[i][j]].c_str());
         }
         printf("\n");
#ifdef PRINTSTUFF
         printf("printf(\"eval %%x parent %%x nt %s \",this,parent);\n",name[lhs[i]].c_str());
         for (j=0;j<rhs[i].size();j++) {
            for (k=0,m=1+(lhs[i]==rhs[i][j]);k<j;k++) if (rhs[i][j] == rhs[i][k]) m++;
            printf("printf(\" %%x\",&%s%d);\n",cvt(name[rhs[i][j]]),m);
         }
         printf("printf(\"\\n\");\n");
         //printf("\n   return 0;\n}\n\n");
#endif
         printf("END\n\n");
   }



   return 1;
}

int main(){
   int i,j,k,m,n,r;
   char tmp[1000];

   if (!readgram()) return 1;
   //printgram();
   printc();
   fclose(stdout);
   return 0;
}
